//
//  ViewController.swift
//  MyApp
//
//  Created by 杉本裕樹 on 2016/10/15.
//  Copyright © 2016年 cl. All rights reserved.
//

import UIKit
import PassKit

class ViewController: UIViewController {
    let summary = PKPaymentSummaryItem(label: "ひまわりの花", amount: NSDecimalNumber(string: "1200"), type: .final)
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        let button = PKPaymentButton(type: .buy, style: .black)
        button.addTarget(self, action: #selector(ViewController.tapPaymentButton), for: .touchUpInside)
        button.frame.origin.y = view.frame.size.height - 100
        button.center.x = view.center.x
        view.addSubview(button)
    }
    
    func tapPaymentButton() {
        let paymentRequest = PKPaymentRequest()
        paymentRequest.paymentSummaryItems = [summary]
        paymentRequest.merchantIdentifier = "merchant.com.clhs09.sample"
        paymentRequest.merchantCapabilities = .capability3DS
        paymentRequest.countryCode = "JP"
        paymentRequest.currencyCode = "JPY"
        paymentRequest.requiredShippingAddressFields = [.email, .name, .phone, .postalAddress]
        paymentRequest.supportedNetworks = [
            PKPaymentNetwork.amex,
            PKPaymentNetwork.discover,
            PKPaymentNetwork.masterCard,
            PKPaymentNetwork.visa
        ]
        
        let paymentController = PKPaymentAuthorizationController(paymentRequest: paymentRequest)
        paymentController.delegate = self
        paymentController.present(completion: nil)
    }
}

extension ViewController: PKPaymentAuthorizationControllerDelegate {
    func paymentAuthorizationController(_ controller: PKPaymentAuthorizationController, didAuthorizePayment payment: PKPayment, completion: @escaping (PKPaymentAuthorizationStatus) -> Void) {
        
        // ユーザーが決済を許可した時に呼ばれる
        // paymentの中にトークン情報が入っているので、これを使って決済する
        
        completion(.success)
    }
    
    func paymentAuthorizationControllerDidFinish(_ controller: PKPaymentAuthorizationController) {
        // 決済完了時・キャンセルを押した時に呼ばれる
        controller.dismiss(completion: nil)
    }
}
